import "./style.css";
import { reactive as w, ref as N, watchEffect as D, onActivated as j, nextTick as F, resolveComponent as f, createElementBlock as x, openBlock as T, createElementVNode as l, createVNode as v, withCtx as V, withDirectives as P, vShow as W, onBeforeUnmount as A } from "vue";
import { Button as J } from "@opentiny/vue";
import { LinkButton as O, CloseIcon as U, VueMonaco as H } from "@opentiny/tiny-engine-common";
import { useCanvas as g, useNotify as y, useModal as b, useHelp as I } from "@opentiny/tiny-engine-meta-register";
import { initCompletion as z } from "@opentiny/tiny-engine-common/js/completion";
import { lint as R, initLinter as Y } from "@opentiny/tiny-engine-common/js/linter";
import { insertName as q, string2Ast as E, formatString as G, ast2String as K } from "@opentiny/tiny-engine-common/js/ast";
import { constants as Q } from "@opentiny/tiny-engine-utils";
import { isFunction as X } from "@opentiny/vue-renderless/grid/static";
const { SCHEMA_DATA_TYPE: k } = Q, r = w({
  linterWorker: null,
  script: "",
  isChanged: !1,
  hasError: !1,
  editorSelection: null,
  completionProvider: null
}), a = N(null);
let _ = null;
const S = () => {
  var t, n;
  const o = ((n = (t = g()).getSchema) == null ? void 0 : n.call(t)) || {};
  return o.methods = (o == null ? void 0 : o.methods) || {}, o.methods;
}, Z = () => g().pageState.pageSchema && Object.keys(S()) || [], M = () => {
  const t = Object.entries(S()).map(([n, e]) => q(n, e.value)).join(`
`);
  try {
    _ = E(t);
  } catch (n) {
    y({
      type: "error",
      message: `代码静态检查有错误：${n}`
    });
  }
  return t;
}, $ = (o) => {
  if (r.isChanged = o !== r.script, !a.value)
    return;
  const t = a.value.getEditor().getModel();
  R(t, r.linterWorker);
}, ee = ({ name: o, content: t }) => {
  if (!o)
    return;
  const n = S(), e = {
    type: k.JSFunction,
    value: t
  };
  g().updateSchema({ methods: { ...n, [o]: e } });
}, B = () => {
  const { message: o } = b();
  if (!r.isChanged)
    return !1;
  if (r.hasError)
    return o({
      status: "error",
      message: "代码静态检查有错误，请先修改后再保存"
    }), !1;
  const t = a.value.getEditor().getValue(), n = E(t), e = {};
  return n.program.body.forEach((s, i) => {
    var m, u;
    const d = (m = s == null ? void 0 : s.id) == null ? void 0 : m.name;
    (u = n.program.body[i + 1]) != null && u.leadingComments && s.trailingComments === n.program.body[i + 1].leadingComments && delete s.trailingComments;
    const p = G(K(s).trim(), "javascript");
    d && (e[d] = {
      type: k.JSFunction,
      value: p
    });
  }), g().updateSchema({ methods: e }), g().setSaved(!1), r.isChanged = !1, y({
    type: "success",
    message: "保存成功！"
  }), !0;
}, te = (o) => (t) => {
  const { confirm: n } = b(), e = X(t) ? t : () => o("close");
  if (!r.isChanged) {
    e(!0);
    return;
  }
  n({
    title: "提示",
    message: "有改动未保存，您确定保存并关闭吗？",
    exec() {
      e(B());
    },
    cancel() {
      e(!0);
    }
  });
}, oe = () => {
  if (!r.editorSelection || !a.value)
    return;
  const o = a.value.getEditor();
  o.setSelection(r.editorSelection), o.focus();
  const t = o.getTopForLineNumber(r.editorSelection.startLineNumber - 1);
  o.setScrollPosition(
    {
      scrollLeft: 0,
      scrollTop: t
    },
    0
  );
}, ne = (o) => {
  var e;
  if (!o)
    return;
  const t = _ == null ? void 0 : _.program.body.filter((s) => {
    var i;
    return o === ((i = s == null ? void 0 : s.id) == null ? void 0 : i.name);
  });
  if (t.length === 0)
    return;
  const n = (e = t[0]) == null ? void 0 : e.loc;
  n && (r.editorSelection = {
    startColumn: n.start.column,
    startLineNumber: n.start.line,
    endColumn: n.end.column + 1,
    endLineNumber: n.end.line
  }), r.editorSelection && oe();
}, se = ({ emit: o }) => (D(() => {
  r.script = M();
}), j(() => {
  F(() => {
    var t;
    r.script = M(), (t = a.value) == null || t.focus(), window.dispatchEvent(new Event("resize"));
  });
}), {
  state: r,
  monaco: a,
  change: $,
  saveMethods: B,
  close: te(o)
}), re = (o, t) => {
  const n = o.__vccOpts || o;
  for (const [e, s] of t)
    n[e] = s;
  return n;
}, ie = {
  saveMethod: ee,
  highlightMethod: ne,
  getMethodNameList: Z,
  getMethods: S
}, ce = {
  components: {
    MonacoEditor: H,
    TinyButton: J,
    CloseIcon: U,
    LinkButton: O
  },
  emits: ["close"],
  setup(o, { emit: t }) {
    const n = I().getDocsUrl("script"), { state: e, monaco: s, change: i, close: d, saveMethods: p } = se({ emit: t }), m = {
      language: "javascript",
      minimap: {
        enabled: !1
      },
      placeholder: `// ✅ 函数声明可以保存
       function topLevelFunction(){ 
      ​ ​ const message = 'hello tiny-engine.' 
      ​ ​ console.log(message) 
      } 
 
      // ❌ 顶层/常规 变量声明 
 const someVariable = 42 
      // ❌ 表达式 
 const result = someVariable + 10`,
      // 禁用滚动条边边一直显示的边框
      overviewRulerBorder: !1,
      renderLineHighlightOnlyWhenFocus: !0
    }, u = (h) => {
      var c;
      s.value && (e.completionProvider = z(s.value.getMonaco(), (c = s.value.getEditor()) == null ? void 0 : c.getModel()), e.linterWorker = Y(h, s.value.getMonaco(), e));
    };
    return A(() => {
      var h, c, C;
      (h = e.completionProvider) == null || h.forEach((L) => {
        L.dispose();
      }), (C = (c = e.linterWorker) == null ? void 0 : c.terminate) == null || C.call(c);
    }), {
      state: e,
      monaco: s,
      options: m,
      close: d,
      change: i,
      saveMethods: p,
      editorDidMount: u,
      docsUrl: n
    };
  }
}, le = { class: "plugin-page-js-container" }, ae = { class: "code-edit-head" }, de = { class: "head-left" }, me = { class: "head-right" }, ue = { class: "dots" }, pe = { class: "code-edit-content" };
function ge(o, t, n, e, s, i) {
  const d = f("link-button"), p = f("tiny-button"), m = f("close-icon"), u = f("monaco-editor");
  return T(), x("div", le, [
    l("div", ae, [
      l("div", de, [
        t[0] || (t[0] = l("span", { class: "title" }, "页面 JS", -1)),
        v(d, { href: e.docsUrl }, null, 8, ["href"])
      ]),
      l("div", me, [
        v(p, {
          type: "primary",
          class: "save-btn",
          onClick: e.saveMethods
        }, {
          default: V(() => [
            t[1] || (t[1] = l("span", null, "保存", -1)),
            P(l("span", ue, null, 512), [
              [W, e.state.isChanged]
            ])
          ]),
          _: 1
        }, 8, ["onClick"]),
        v(m, { onClose: e.close }, null, 8, ["onClose"])
      ])
    ]),
    l("div", pe, [
      v(u, {
        ref: "monaco",
        value: e.state.script,
        options: e.options,
        onChange: e.change,
        onEditorDidMount: e.editorDidMount,
        onShortcutSave: e.saveMethods
      }, null, 8, ["value", "options", "onChange", "onEditorDidMount", "onShortcutSave"])
    ])
  ]);
}
const he = /* @__PURE__ */ re(ce, [["render", ge], ["__scopeId", "data-v-a6c97b37"]]), fe = {
  id: "engine.plugins.pagecontroller",
  title: "页面 JS",
  type: "plugins",
  icon: "plugin-icon-js",
  align: "top",
  confirm: "close"
  // 当点击插件栏切换或关闭前是否需要确认, 会调用插件中confirm值指定的方法，e.g. 此处指向 close方法，会调用插件的close方法执行确认逻辑
}, Le = {
  ...fe,
  apis: ie,
  entry: he
};
export {
  Le as default
};
